var search_data = {"index":{"searchIndex":["gaddag","arc","node","path","word","add()","add_final_letter()","arc?()","create_arc()","create_final_arc()","create_final_path()","create_path()","final_path?()","final_paths()","final_paths()","find()","follow_arc()","follow_path()","include_delimiter?()","new()","new()","new()","new()","new()","path?()","reversed_prefix_letters()","start_with?()","suffix_letters()","to_ary()","to_delimited_paths()","to_s()","to_s()","to_word()"],"longSearchIndex":["gaddag","gaddag::arc","gaddag::node","gaddag::path","gaddag::word","gaddag#add()","gaddag::arc#add_final_letter()","gaddag::node#arc?()","gaddag::node#create_arc()","gaddag::node#create_final_arc()","gaddag::node#create_final_path()","gaddag::node#create_path()","gaddag::node#final_path?()","gaddag::arc#final_paths()","gaddag::node#final_paths()","gaddag#find()","gaddag::node#follow_arc()","gaddag::node#follow_path()","gaddag::path#include_delimiter?()","gaddag::new()","gaddag::arc::new()","gaddag::node::new()","gaddag::path::new()","gaddag::word::new()","gaddag::node#path?()","gaddag::path#reversed_prefix_letters()","gaddag::path#start_with?()","gaddag::path#suffix_letters()","gaddag::path#to_ary()","gaddag::word#to_delimited_paths()","gaddag::path#to_s()","gaddag::word#to_s()","gaddag::path#to_word()"],"info":[["GADDAG","","GADDAG.html","","<p>Implementation of the GADDAG data structure\n"],["GADDAG::Arc","","GADDAG/Arc.html","","<p>Represents an arc pointing to a destination node with optional final letters\n"],["GADDAG::Node","","GADDAG/Node.html","","<p>Represents a node in the GADDAG data structure\n"],["GADDAG::Path","","GADDAG/Path.html","","<p>Represents a (final) path within the GADDAG data structure\n"],["GADDAG::Word","","GADDAG/Word.html","","<p>Represents a word in the GADDAG data structure\n"],["add","GADDAG","GADDAG.html#method-i-add","(word)","<p>Adds a word to the GADDAG @param word [String] the word to be added @return [GADDAG] the GADDAG instance …\n"],["add_final_letter","GADDAG::Arc","GADDAG/Arc.html#method-i-add_final_letter","(letter)","<p>Adds a final letter to the arc. A final letter is a letter that, when appended to the letter path, forms …\n"],["arc?","GADDAG::Node","GADDAG/Node.html#method-i-arc-3F","(letter)","<p>Checks whether an outgoing arc for the given letter exists @param letter [String] the letter to check …\n"],["create_arc","GADDAG::Node","GADDAG/Node.html#method-i-create_arc","(letter, destination = Node.new)","<p>Creates an outgoing arc for a letter to a destination node @param letter [String] the letter to be added …\n"],["create_final_arc","GADDAG::Node","GADDAG/Node.html#method-i-create_final_arc","(letter, final_letter, destination = Node.new)","<p>Creates a final outgoing arc for a letter to a destination node. Effectively this will add a final letter …\n"],["create_final_path","GADDAG::Node","GADDAG/Node.html#method-i-create_final_path","(letters, destinations = [])","<p>Creates a path for a list of letters and optional destination nodes, ommiting the last node, and marking …\n"],["create_path","GADDAG::Node","GADDAG/Node.html#method-i-create_path","(letters, destinations = [])","<p>Creates a path for a list of letters and optional destination nodes @param letters [Array&lt;String&gt;] …\n"],["final_path?","GADDAG::Node","GADDAG/Node.html#method-i-final_path-3F","(letters)","<p>Checks whether a final path exists for the given list of letters @param letters [Array&lt;String&gt;] …\n"],["final_paths","GADDAG::Arc","GADDAG/Arc.html#method-i-final_paths","()","<p>Returns all paths starting at this arc that are final @return [Array&lt;Path&gt;] a list of final paths …\n"],["final_paths","GADDAG::Node","GADDAG/Node.html#method-i-final_paths","()","<p>Returns all paths from this node that are final. The set of final paths are all paths for which the last …\n"],["find","GADDAG","GADDAG.html#method-i-find","(substring)","<p>Finds all words that contain the given substring @param substring [String] the substring to search for …\n"],["follow_arc","GADDAG::Node","GADDAG/Node.html#method-i-follow_arc","(letter)","<p>Follows a single outgoing arc for a given letter @param letter [String] the letter that should be followed …\n"],["follow_path","GADDAG::Node","GADDAG/Node.html#method-i-follow_path","(letters)","<p>Recursively follows a list of letters @param letters [Array&lt;String&gt;] the letters to be followed …\n"],["include_delimiter?","GADDAG::Path","GADDAG/Path.html#method-i-include_delimiter-3F","()","<p>Tells whether the path includes {GADDAG::DELIMITER} @return [Boolean] whether this path includes the …\n"],["new","GADDAG","GADDAG.html#method-c-new","()","<p>Initializes a GADDAG @return [GADDAG]\n"],["new","GADDAG::Arc","GADDAG/Arc.html#method-c-new","(destination)","<p>Initializes a GADDAG arc @param destination [Node] the destination node @return [Arc]\n"],["new","GADDAG::Node","GADDAG/Node.html#method-c-new","()","<p>Initializes a GADDAG node @return [Node]\n"],["new","GADDAG::Path","GADDAG/Path.html#method-c-new","(letters)","<p>Initializes a GADDAG path @param letters [Array&lt;String&gt;] a list of letters, containing a reversed …\n"],["new","GADDAG::Word","GADDAG/Word.html#method-c-new","(letters)","<p>Initializes a GADDAG word @param letters [Array&lt;String&gt;] an ordered list of letters of which the …\n"],["path?","GADDAG::Node","GADDAG/Node.html#method-i-path-3F","(letters)","<p>Checks whether a path exists for the given list of letters @param letters [Array&lt;String&gt;] the letter …\n"],["reversed_prefix_letters","GADDAG::Path","GADDAG/Path.html#method-i-reversed_prefix_letters","()","<p>Returns the reversed prefix of this path @return [Array&lt;String&gt;] the first portion of this path: …\n"],["start_with?","GADDAG::Path","GADDAG/Path.html#method-i-start_with-3F","(letters)","<p>Tells whether the path starts with the given letters @param letters [Array&lt;String&gt;] the letters …\n"],["suffix_letters","GADDAG::Path","GADDAG/Path.html#method-i-suffix_letters","()","<p>Returns the suffix of this path @return [Array&lt;String&gt;] the last portion of this path: the suffix …\n"],["to_ary","GADDAG::Path","GADDAG/Path.html#method-i-to_ary","()","<p>Coerces into an Array. @example\n\n<pre class=\"ruby\">[<span class=\"ruby-string\">&#39;K&#39;</span>, <span class=\"ruby-string\">&#39;E&#39;</span>] <span class=\"ruby-operator\">+</span> <span class=\"ruby-constant\">Path</span>.<span class=\"ruby-identifier\">new</span>(<span class=\"ruby-node\">%w(A R B)</span>) <span class=\"ruby-comment\"># =&gt; [&#39;K&#39;, &#39;E&#39;, &#39;A&#39;, &#39;R&#39;, &#39;B&#39;]</span>\n</pre>\n<p>@return …\n"],["to_delimited_paths","GADDAG::Word","GADDAG/Word.html#method-i-to_delimited_paths","()","<p>Constructs a list of delimited GADDAG paths from this word @return [Array&lt;Path&gt;] a list of paths, …\n"],["to_s","GADDAG::Path","GADDAG/Path.html#method-i-to_s","()","<p>Returns a string presentation of this path @return the string represtentation, letters are delimited …\n"],["to_s","GADDAG::Word","GADDAG/Word.html#method-i-to_s","()","<p>Returns the word as string @return a string representation of the word\n"],["to_word","GADDAG::Path","GADDAG/Path.html#method-i-to_word","()","<p>Constructs a word from the partially reversed letter path @return [Word] the word that is encoded within …\n"]]}}